/*
 * Copyright (c) 2007 Tomi Aarnio
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

//----------------------------------------------------------------------
// "Hello, World" on M3G: a simple animation player
//----------------------------------------------------------------------

package com.graphicsformasses.ch12;
import com.graphicsformasses.framework.DemoTask;

import java.util.*;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.game.GameCanvas;
import javax.microedition.m3g.*;

public class HelloWorld extends DemoTask
{
    private Graphics3D g3d = Graphics3D.getInstance();
    private World myWorld;
    
    protected String getName() {
        return "HelloWorld";
    }

    protected void start() {
        try {
            myWorld = (World)Loader.load("/pond.m3g")[0];
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    protected boolean run(int time, int keyStates, int keysChanged, Graphics g) {
        g3d.bindTarget(g, true, Graphics3D.OVERWRITE|Graphics3D.ANTIALIAS);
        myWorld.animate(time);
        myWorld.align(null);
        g3d.render(myWorld);
        g3d.releaseTarget();
        return true;
    }
}
