/*
 * Copyright (c) 2007 Kimmo Roimela
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.graphicsformasses.ch13;
import com.graphicsformasses.framework.DemoTask;

import java.lang.Math;
import javax.microedition.lcdui.Graphics;
import javax.microedition.m3g.*;

public class ColorClear extends DemoTask
{
    private Graphics3D g3d = Graphics3D.getInstance();
    private Background bg = new Background();
    
    protected String getName() {
        return "Color clear";
    }

    protected boolean run(int time, int keyStates, int keysChanged, Graphics g) {
        float t = time / 1000.f;

        int red   = (int)(127.5f * Math.cos(t) + 128.f);
        int green = (int)(127.5f * Math.cos(t - 1.7f) + 128.f);
        int blue  = (int)(127.5f * Math.cos(t - 3.2f) + 128.f);

        bg.setColor(red << 16 | green << 8 | blue);

        g3d.bindTarget(g);
        g3d.clear(bg);
        g3d.releaseTarget();

        return true;
    }
}
