/*
 * Copyright (c) 2007 Tomi Aarnio
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.graphicsformasses.ch13;
import com.graphicsformasses.framework.DemoTask;

import java.lang.Math;
import javax.microedition.lcdui.Graphics;
import javax.microedition.m3g.*;

public class HalfClear extends DemoTask
{
    private Graphics3D g3d = Graphics3D.getInstance();
    private Background myBackground = new Background();
    
    protected String getName() {
        return "Half clear";
    }

    protected boolean run(int time, int keyStates, int keysChanged, Graphics g) {
        
        int hints = Graphics3D.OVERWRITE | Graphics3D.ANTIALIAS;
        
        int width = g.getClipWidth();
        int height = g.getClipHeight();
        
        try {
            g3d.bindTarget(g, true, hints);
            g3d.setViewport(0, 0, width, height/2);        // top half
            myBackground.setColor(0x00FF0000);             // red in 0xARGB format
            g3d.clear(myBackground);
            g3d.setViewport(0, height/2, width, height/2); // bottom half
            myBackground.setColor(0x000000FF);             // blue
            g3d.clear(myBackground);
        }
        finally {
            g3d.releaseTarget();
        }

        return true;
    }
}
