/*
 * Copyright (c) 2007 Tomi Aarnio
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.graphicsformasses.ch14;
import com.graphicsformasses.framework.DemoTask;

import javax.microedition.m3g.*;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

public class BackgroundScroll extends DemoTask
{
    private Graphics3D g3d = Graphics3D.getInstance();
    
    private Background myBg = new Background();
    
    private int screenWidth, screenHeight;
    
    protected String getName() {
        return "Background scroll";
    }
    
    protected void start() {
        try {
            myBg.setImage((Image2D) Loader.load("/brick.png")[0]);
        }
        catch (Exception e) {
            throw new Error("Background image not found.");
        }
        myBg.setImageMode(Background.REPEAT, Background.BORDER);
        myBg.setColor(0x00CCFFCC);
    }

    protected boolean run(int time,
                          int keyStates,
                          int keysChanged,
                          Graphics g) {

        myBg.setCrop(myBg.getCropX()+1, 18, g.getClipWidth(), g.getClipHeight());
        
        g3d.bindTarget(g);
        g3d.clear(myBg);
        g3d.releaseTarget();
        return true;
    }
}
